function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

import readline from 'node:readline';
import stripAnsi from 'strip-ansi';
import chalk from 'chalk';
export var Logger = /*#__PURE__*/function () {
  function Logger() {
    _classCallCheck(this, Logger);
  }

  _createClass(Logger, [{
    key: "log",
    value: function log(msg, tag) {
      tag ? console.log(Logger.format(Logger.chalkTag(tag), msg)) : console.log(msg);
    }
  }, {
    key: "info",
    value: function info(msg, tag) {
      console.log(Logger.format(chalk.bgBlue.black(' INFO ') + (tag ? Logger.chalkTag(tag) : ''), msg));
    }
  }, {
    key: "done",
    value: function done(msg, tag) {
      console.log(Logger.format(chalk.bgGreen.black(' DONE ') + (tag ? Logger.chalkTag(tag) : ''), msg));
    }
  }, {
    key: "warn",
    value: function warn(msg, tag) {
      console.warn(Logger.format(chalk.bgYellow.black(' WARN ') + (tag ? Logger.chalkTag(tag) : ''), chalk.yellow(msg)));
    }
  }, {
    key: "error",
    value: function error(msg, tag) {
      console.error(Logger.format(chalk.bgRed(' ERROR ') + (tag ? Logger.chalkTag(tag) : ''), chalk.red(msg)));
    }
  }, {
    key: "clearConsole",
    value: function clearConsole(title) {
      if (process.stdout.isTTY) {
        var blank = '\n'.repeat(process.stdout.rows);
        console.log(blank);
        readline.cursorTo(process.stdout, 0, 0);
        readline.clearScreenDown(process.stdout);

        if (title) {
          console.log(title);
        }
      }
    }
  }], [{
    key: "format",
    value: function format(label, msg) {
      return msg.split('\n').map(function (line, i) {
        return i === 0 ? "".concat(label, " ").concat(line) : line.padStart(stripAnsi(label).length + line.length + 1);
      }).join('\n');
    }
  }, {
    key: "chalkTag",
    value: function chalkTag(msg) {
      return chalk.bgBlackBright.white.dim(" ".concat(msg, " "));
    }
  }]);

  return Logger;
}();
var logger = new Logger();
export default logger;